#include<iostream>
using namespace std;
int main ()
{
    int N;
    cin>>N;
    bool mas[N+1][N+1];
    for (int i=1; i<=N; i++)
    {
        for (int q=1; q<=N; q++)
        {
            mas[i][q]=0;
        }
    }
    for (int i=0; i<N-1; i++)
    {
        int U, V;
        cin>>U>>V;
        mas[U][V]=1;
    }
    int Q;
    cin>>Q;
    int spisuk[Q];
    for (int i=0; i<Q; i++)
    {
        cin>>spisuk[i];
    }
        bool dali[N+1];
    for (int i=0; i<N+1; i++)
    {
        dali[i]=false;
    }
    for (int i=0; i<Q; i++)
    {
        for  (int q=1; q<=N; q++)
        {
            if (mas[spisuk[i]][q]==1)
            {
                dali[q]=true;
            }
        }
        int br=0;
        for (int a=1; a<=N; a++)
        {
            if (dali[a]==true) br++;
        }
        cout<<br<<endl;
    }
    return 0;
}
